# The TaskList API 

The Tasklist API is a simple PHP API project designed to show learners what a simple API implemented in PHP might look like, with the classical Task list subject.

The API makes use of the Slim framework for routing and PHP-DI's Slim bridge for dependency injection, with its own custom skeleton (e.g. not Slim's own app skeleton). The app furthermore makes usage of the Repository pattern for handling connections with the database, keeping everything clean and in one place.

The project makes use of the PSR-4 and PSR-7 PHP standards.

### Why not use an ORM like Doctrine?

We're not using any third party libraries because this project is meant to show beginners how things are done under the hood. Beginners should really only start using a framework or advanced concepts like ORM when they've covered their bases first.

### API documentation (WIP)

Documentation relating the API will be published on an OpenAPI spec file later.


## Project dependencies

 - PHP 8.2 and up (earlier versions are unsupported)
 - PDO PHP extension
 - PHP JSON extension

Make sure you install both PDO and JSON for php8.2 (ex. on Ubuntu, ``php8.2-pdo``).

## Running the API

Point your web server to the root directory and serve index.php. Make sure rewrte is enabled if using Apache. Use a router file if using PHP's built-in server.