<?php declare(strict_types=1);

namespace Config;

use Dotenv\Dotenv;

class Config
{

    private Dotenv $env;

    public function __construct()
    {
        $this->env = Dotenv::createImmutable(dirname(__DIR__, 2));
        $this->env->load();
    }

    public function getDbHost(): string {
        return $_ENV['DB_HOST'] ?? 'localhost';
    }

    public function getDbUser(): string {
        return $_ENV['DB_USER'] ?? 'root';
    }

    public function getDbPassword(): string {
        return $_ENV['DB_PASSWORD'];
    }

    public function getDbName(): string {
        return $_ENV['DB_NAME'];
    }

    public function getDbCharset(): string {
        return $_ENV['DB_CHARSET'] ?? 'utf8mb4';
    }

    public function getDbCollation(): string {
        return $_ENV['DB_COLLATION'] ?? 'utf8mb4_unicode_ci';
    }

    public function getDbPort(): int
    {
        return (int) $_ENV['DB_PORT'] ?? 3306;
    }
}