<?php declare(strict_types=1);

namespace Controllers;

use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Utils\StructuredResponseBuilder;

class HomeFrontController
{

    private $container;

    private $builder;


    /**
     * @param StructuredResponseBuilder $builder Response Builder interface.
     */
    public function __construct(StructuredResponseBuilder $builder)
    {
        $this->builder = $builder;
    }

    public function home(ServerRequestInterface $request, ResponseInterface $response): ResponseInterface
    {
        $builderResponse = $this->builder
            ->setError()
            ->setErrorMessage("This is an API and is therefore not meant to handle requests with your browser.")
            ->setErrorCode(400)
            ->setPayload([])
            ->build();

        // ResponseInterface is immutable
        $newResponse = $response;
        $newResponse->withStatus(400, "Bad Request")->withHeader('Content-Type', 'application/json');

        $newResponse->getBody()->write($builderResponse);

        return $newResponse;
    }

}