<?php

namespace Interfaces;

use Models\Task;

interface TaskDao
{
    /**
     * Inserts the specified task.
     *
     * @param Task $task The task to persist.
     * @return int The new task's ID, or 0 if the operation was unsucessful
     */
    public function create(Task $task): int;

    /**
     * Returns an array of Tasks
     * @return array
     */
    public function readAll(): array;

    public function readById($id): Task;

    public function update(Task $task): bool;

    public function delete(Task $task): bool;

}